/*******************************************************************************
 * Copyright (C) 2010 by 52 North Initiative for Geospatial Open Source Software
 * GmbH
 *
 * Contact: Andreas Wytzisk 52 North Initiative for Geospatial Open Source
 * Software GmbH Martin-Luther-King-Weg 24 48155 Muenster, Germany
 * info@52north.org
 *
 * This program is free software; you can redistribute and/or modify it under
 * the terms of the GNU General Public License version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed WITHOUT ANY WARRANTY; even without the implied
 * WARRANTY OF MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program (see gnu-gpl v2.txt). If not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA or
 * visit the Free Software Foundation web page, http://www.fsf.org.
 ******************************************************************************/
package org.n52.security.common.util;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;

public interface KeyValuePairCollection extends Iterable<KeyValuePair> {

    public static KeyValuePairCollection EMPTY_COLLECTION = new KeyValuePairCollection() {
        @Override
        public Collection<String> values(KeyMatcher key) {
            return Collections.emptyList();
        }

        @Override
        public void updateUnique(KeyMatcher key, KeyValuePair pair) {
        }

        @Override
        public int size() {
            return 0;
        }

        @Override
        public Collection<String> keys() {
            return Collections.emptyList();
        }

        @Override
        public Iterator<KeyValuePair> iterator() {
            return Collections.<KeyValuePair>emptyList().iterator();
        }

        @Override
        public KeyValuePair getUnique(KeyMatcher key) throws NonUniqueException {
            return null;
        }

        @Override
        public KeyValuePairCollection getAll(KeyMatcher key) {
            return this;
        }

        @Override
        public boolean containsKey(KeyMatcher key) {
            return false;
        }

        @Override
        public boolean contains(KeyValuePair pair) {
            return false;
        }

        @Override
        public void addAll(Collection<KeyValuePair> pairs) {
        }

        @Override
        public void add(KeyValuePair pair) {
        }

        @Override
        public int delete(KeyMatcher key) {
            return 0;
        };
    };

    public Iterator<KeyValuePair> iterator();

    public Collection<String> keys();

    public Collection<String> values(KeyMatcher key);

    public KeyValuePairCollection getAll(KeyMatcher key);

    public KeyValuePair getUnique(KeyMatcher key) throws NonUniqueException;

    public boolean containsKey(KeyMatcher key);

    public void add(KeyValuePair pair);

    public void addAll(Collection<KeyValuePair> pairs);

    public void updateUnique(KeyMatcher key, KeyValuePair pair);

    public int size();

    public boolean contains(KeyValuePair pair);

    public int delete(KeyMatcher key);


}
